<?php
include '../config.php';  include '../checkSession.php';
$newimg = trim($_POST['newimgimagenPrincipal']);
$newfile1 = trim($_POST['newfilearchivoInformeAnual']);
$newfile2 = trim($_POST['newfilearchivoCaracteristicasAdicionales']);

$oldimg = trim($_POST['oldimg']);
$oldimg2 = trim($_POST['oldimg2']);
$oldimg3 = trim($_POST['oldimg3']);

$lang = $_GET['lang'];
$id = $_GET['id'];

$tituloCaracteristicasAdicionales = trim(($_POST['tituloCaracteristicasAdicionales']);
$archivoCaracteristicasAdicionales = trim($_POST['archivoCaracteristicasAdicionales']);


$imagen = $oldimg;
$file1= $oldimg2;
$file2 = $oldimg3;


    if($newfile2 == 1){

        if (isset($_FILES['archivoCaracteristicasAdicionales']) && $_FILES['archivoCaracteristicasAdicionales']['error'] === UPLOAD_ERR_OK)
        {
            // get details of the uploaded file
            $fileTmpPath3 = $_FILES['archivoCaracteristicasAdicionales']['tmp_name'];
            $fileName3 = $_FILES['archivoCaracteristicasAdicionales']['name'];
            $fileSize3 = $_FILES['archivoCaracteristicasAdicionales']['size'];
            $fileType3 = $_FILES['archivoCaracteristicasAdicionales']['type'];
            $fileNameCmps3 = explode(".", $fileName3);
            $fileExtension3 = strtolower(end($fileNameCmps3));
        
            // sanitize file-name
            $newFileName3 = "Archivo_Caracteristicas_Adicionales".$lang. '.' . $fileExtension3;
    
            // check if file has one of the following extensions
            $allowedfileExtensions3 = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'zip');
        
            if (in_array($fileExtension3, $allowedfileExtensions3))
            {
            ///////////////SUBIR A AWS
                /// AWS API keys
                $aws_access_key_id = $aws_access_key_id;
                $aws_secret_access_key = $aws_secret_access_key;
                // Bucket
                $bucket_name = $bucket_name;
                // AWS region and Host Name (Host names are different for each AWS region)
                // As an example these are set to us-east-1 (US Standard)
                $aws_region = $aws_region;
                $host_name = $bucket_name . '.s3.amazonaws.com';

                // Server path where content is present. This is just an example
                //$content_path = $dest_path;
                $content3 = file_get_contents($fileTmpPath3);

                // AWS file permissions
                $content_acl = 'public-read';

                // MIME type of file. Very important to set if you later plan to load the file from a S3 url in the browser (images, for example)
                
                $content_type3 = $fileExtension3;

                if($content_type3 == 'image/svg' ){ $content_type3 = "image/svg+xml";}
                if($content_type3 == 'zip' ){ $content_type3 = "application/zip";}
                if($content_type3 == 'doc' || $content_type3 == 'docx' ){ $content_type3 = "application/msword";}
                if($content_type3 == 'xls' || $content_type3 == 'xlsx' ){ $content_type3 = "application/vnd.ms-excel";}
                if($content_type3 == 'pdf' || $content_type3 == 'pdf' ){ $content_type3 = "application/pdf";}
                // Name of content on S3
                $content_title3 = 'docs/estadisticas-informacion/'.$lang.'/'.$newFileName3;

                // Service name for S3
                $aws_service_name = 's3';

                // UTC timestamp and date
                $timestamp = gmdate('Ymd\THis\Z');
                $date = gmdate('Ymd');

                // HTTP request headers as key & value
                $request_headers = array();
                $request_headers['Content-Type'] = $content_type3;
                $request_headers['Content-Disposition'] = 'inline';
                $request_headers['Date'] = $timestamp;
                $request_headers['Host'] = $host_name;
                $request_headers['x-amz-acl'] = $content_acl;
                $request_headers['x-amz-content-sha256'] = hash('sha256', $content3);
                // Sort it in ascending order
                ksort($request_headers);

                // Canonical headers
                $canonical_headers = [];
                foreach($request_headers as $key => $value) {
                    $canonical_headers[] = strtolower($key) . ":" . $value;
                }
                $canonical_headers = implode("\n", $canonical_headers);

                // Signed headers
                $signed_headers = [];
                foreach($request_headers as $key => $value) {
                    $signed_headers[] = strtolower($key);
                }
                $signed_headers = implode(";", $signed_headers);

                // Cannonical request 
                $canonical_request = [];
                $canonical_request[] = "PUT";
                $canonical_request[] = "/" . $content_title3;
                $canonical_request[] = "";
                $canonical_request[] = $canonical_headers;
                $canonical_request[] = "";
                $canonical_request[] = $signed_headers;
                $canonical_request[] = hash('sha256', $content3);
                $canonical_request = implode("\n", $canonical_request);
                $hashed_canonical_request = hash('sha256', $canonical_request);

                // AWS Scope
                $scope = [];
                $scope[] = $date;
                $scope[] = $aws_region;
                $scope[] = $aws_service_name;
                $scope[] = "aws4_request";

                // String to sign
                $string_to_sign = [];
                $string_to_sign[] = "AWS4-HMAC-SHA256"; 
                $string_to_sign[] = $timestamp; 
                $string_to_sign[] = implode('/', $scope);
                $string_to_sign[] = $hashed_canonical_request;
                $string_to_sign = implode("\n", $string_to_sign);

                // Signing key
                $kSecret = 'AWS4' . $aws_secret_access_key;
                $kDate = hash_hmac('sha256', $date, $kSecret, true);
                $kRegion = hash_hmac('sha256', $aws_region, $kDate, true);
                $kService = hash_hmac('sha256', $aws_service_name, $kRegion, true);
                $kSigning = hash_hmac('sha256', 'aws4_request', $kService, true);

                // Signature
                $signature = hash_hmac('sha256', $string_to_sign, $kSigning);

                // Authorization
                $authorization = [
                    'Credential=' . $aws_access_key_id . '/' . implode('/', $scope),
                    'SignedHeaders=' . $signed_headers,
                    'Signature=' . $signature
                ];
                $authorization = 'AWS4-HMAC-SHA256' . ' ' . implode( ',', $authorization);

                // Curl headers
                $curl_headers = [ 'Authorization: ' . $authorization ];
                foreach($request_headers as $key => $value) {
                    $curl_headers[] = $key . ": " . $value;
                }

                $url = 'https://' . $host_name . '/' . $content_title3;
                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $curl_headers);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $content3);
                curl_exec($ch);
                $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                if($http_code != 200){
                    echo "Error AWS";
                }
                if($http_code == 200){
                    $file2 = $content_title3;
                }
        
                
            }
            else
            {
                $message = '<p style="color:red; font-size:12px;">Extensión de archivo no válida. Verifica que tu archivo tenga uno de los siguientes formatos: ' . implode(', ', $allowedfileExtensions3).'</p>';
                echo $message;
                exit();
            }
        }
        else
        {
            $message = '<p style="color:red; font-size:12px;">Error en subida de archivo:<br></p> ';
            $message .= '<p style="color:red; font-size:12px;">Error:' . $_FILES['archivoCaracteristicasAdicionales']['error'].'</p>';
            echo $message;
            exit();
        }
        echo $message;
    }

    $curl = curl_init();

    $id = 'ckm38zb0g69gw0917jfci2de1';

    if($lang == "en"){

        curl_setopt_array($curl, array(
            CURLOPT_URL => $endpoint_graph_cms,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS =>'{"query":"mutation MyMutation {\\r\\n  updatePaginaEstadistica(data: {archivoCaracteristicasAdicionales: \\"'.$file2.'\\", tituloCaracteristicasAdicionales: \\"'.$tituloCaracteristicasAdicionales.'\\"}, where: {id: \\"'.$id.'\\"}) {\\r\\n    id\\r\\n  }\\r\\n  unpublishPaginaEstadistica(where: {id: \\"'.$id.'\\"}) {\\r\\n    id\\r\\n  }\\r\\n  publishPaginaEstadistica(where: {id: \\"'.$id.'\\"}, to: PUBLISHED, locales: es_MX) {\\r\\n    id\\r\\n  }\\r\\n}","variables":{}}',
            CURLOPT_HTTPHEADER => array(
              'Content-Type: application/json',
              'Cookie: __cfduid=da2693cdfd39b7377a8a05e305da45b8f1613001694'
            ),
          ));

    }

    if($lang == "es"){

            curl_setopt_array($curl, array(
            CURLOPT_URL => $endpoint_graph_cms,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',

            CURLOPT_POSTFIELDS =>'{"query":"mutation MyMutation {\\r\\n    updatePaginaEstadistica(data: {localizations: {update: {data: {archivoCaracteristicasAdicionales: \\"'.$file2.'\\", tituloCaracteristicasAdicionales: \\"'.$tituloCaracteristicasAdicionales.'\\"}, locale: es_MX}}}, where: {id: \\"'.$id.'\\"}) {\\r\\n      id\\r\\n    }\\r\\n  unpublishPaginaEstadistica(where: {id: \\"'.$id.'\\"}) {\\r\\n    id\\r\\n  }\\r\\n  publishPaginaEstadistica(where: {id: \\"'.$id.'\\"}, to: PUBLISHED, locales: es_MX) {\\r\\n    id\\r\\n  }\\r\\n\\r\\n}\\r\\n","variables":{}}',
            CURLOPT_HTTPHEADER => array(
              'Content-Type: application/json',
              'Cookie: __cfduid=da2693cdfd39b7377a8a05e305da45b8f1613001694'
            ),
          ));

    }


    $response = curl_exec($curl);
    curl_close($curl);
    echo $response;

    $jsonrespuesta = json_decode($response, true);
    $id = $jsonrespuesta['data']['updatePaginaEstadistica']['id'];

//echo $id;

  $sucess = "<p class='successmsg'>Características Adicionales actualizado correctamente</p>";
  $fail = "<p class='errormsg'>Falló la actualización..</p> ";


if(strlen($id)>10){

    echo $sucess;

    $string = $newstatus;
    $string = '"'.$string.'"';
    echo '<script>
        
        setTimeout(() => {
            $(".popUpEstadisticasAdicionales").fadeOut();
        }, 1500);
    </script>';
}

else{
    echo $fail;
}

?>